Attribute VB_Name = "Module2"
Option Explicit

Private Declare Function SetWindowsHookEx Lib "user32" Alias "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hmod As Long, ByVal dwThreadId As Long) As Long
Private Declare Function UnhookWindowsHookEx Lib "user32" (ByVal hHook As Long) As Long
Private Declare Function CallNextHookEx Lib "user32" (ByVal hHook As Long, ByVal ncode As Long, ByVal wParam As Long, lParam As Any) As Long

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Any) As Long
Public Declare Function SendMessageTimeout Lib "user32" Alias "SendMessageTimeoutA" (ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long, ByVal fuFlags As Long, ByVal uTimeout As Long, lpdwResult As Long) As Long
Public Declare Function SendNotifyMessage Lib "user32" Alias "SendNotifyMessageA" (ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SendMessageCallback Lib "user32" Alias "SendMessageCallbackA" (ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long, ByVal lpResultCallBack As Long, ByVal dwData As Long) As Long
Public Declare Function SendDlgItemMessage Lib "user32" Alias "SendDlgItemMessageA" (ByVal hDlg As Long, ByVal nIDDlgItem As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function BroadcastSystemMessage Lib "user32" (ByVal dw As Long, pdw As Long, ByVal un As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Declare Function InSendMessage Lib "user32" () As Long
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function PostThreadMessage Lib "user32" Alias "PostThreadMessageA" (ByVal idThread As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long


Public Const BSM_ALLCOMPONENTS = &H0
Public Const BSM_VXDS = &H1
Public Const BSM_NETDRIVER = &H2
Public Const BSM_INSTALLABLEDRIVERS = &H4
Public Const BSM_APPLICATIONS = &H8
Public Const BSM_ALLDESKTOPS = &H10

Public Const BSF_QUERY = &H1
Public Const BSF_IGNORECURRENTTASK = &H2
Public Const BSF_FLUSHDISK = &H4
Public Const BSF_NOHANG = &H8
Public Const BSF_POSTMESSAGE = &H10
Public Const BSF_FORCEIFHUNG = &H20
Public Const BSF_NOTIMEOUTIFNOTHUNG = &H40

Public Const SMTO_BLOCK = &H1
Public Const SMTO_NORMAL = &H0
Public Const SMTO_ABORTIFHUNG = &H2

Public Const HWND_BROADCAST = &HFFFF&

Public Const WH_CALLWNDPROC = 4
Public Const WH_CALLWNDPROCRET = 12
Public Const WH_CBT = 5
Public Const WH_DEBUG = 9
Public Const WH_FOREGROUNDIDLE = 11
Public Const WH_GETMESSAGE = 3
Public Const WH_HARDWARE = 8
Public Const WH_JOURNALPLAYBACK = 1
Public Const WH_JOURNALRECORD = 0
Public Const WH_KEYBOARD = 2
Public Const WH_MAX = 11
Public Const WH_MIN = (-1)
Public Const WH_MOUSE = 7
Public Const WH_MSGFILTER = (-1)
Public Const WH_SHELL = 10
Public Const WH_SYSMSGFILTER = 6

Public Const MSGF_DIALOGBOX = 0
Public Const MSGF_NEXTWINDOW = 6
Public Const MSGF_SCROLLBAR = 5
Public Const MSGF_MENU = 2

Public Const MSGF_MAINLOOP = 8      'Not used with MsgFilter Hook
Public Const MSGF_MAX = 8           'Not used with MsgFilter Hook
Public Const MSGF_MESSAGEBOX = 1    'Not used with MsgFilter Hook
Public Const MSGF_MOVE = 3          'Not used with MsgFilter Hook
Public Const MSGF_SIZE = 4          'Not used with MsgFilter Hook
Public Const MSGF_DDEMGR = &H8001   'Not used with MsgFilter Hook
Public Const MSGF_USER = 4096       'Not used with MsgFilter Hook


Private Const HC_ACTION = 0
Private Const HC_GETNEXT = 1
Private Const HC_SKIP = 2
Private Const HC_NOREMOVE = 3
Private Const HC_NOREM = HC_NOREMOVE
Private Const HC_SYSMODALOFF = 5
Private Const HC_SYSMODALON = 4


Public Type DEBUGHOOKINFO
        hModuleHook As Long
        Reserved As Long
        lParam As Long
        wParam As Long
        code As Long
End Type

Public Type POINTAPI
        x As Long
        y As Long
End Type

Public Type msg
    hwnd As Long
    message As Long
    wParam As Long
    lParam As Long
    time As Long
    pt As POINTAPI
End Type

Public Type CWPSTRUCT
        lParam As Long
        wParam As Long
        message As Long
        hwnd As Long
End Type

Public Type CWPRETSTRUCT
        lResult As Long
        lParam As Long
        wParam As Long
        message As Long
        hwnd As Long
End Type

Public Const HWND_TOPMOST = -1

Public Const WM_NULL = 0
Public Const WM_SETTEXT = &HC


Private hProcRetHook As Long
Private hProcHook As Long

Public IsHooked As Boolean


'-----------------------------
' SET MESSAGE FILTER HOOK
'-----------------------------
Public Sub SetHooks()
    If IsHooked Then
        MsgBox "Don't hook CALLWNDPROC twice or you will be unable to unhook it."
    Else
        hProcHook = SetWindowsHookEx(WH_CALLWNDPROC, AddressOf WndProc, 0, App.ThreadID)
        hProcRetHook = SetWindowsHookEx(WH_CALLWNDPROCRET, AddressOf WndProcRet, 0, App.ThreadID)
        IsHooked = True
    End If
End Sub

Public Sub RemoveHooks()
    Dim temp As Long
    temp = UnhookWindowsHookEx(hProcRetHook)
    temp = UnhookWindowsHookEx(hProcHook)
    IsHooked = False
End Sub


Public Function WndProcRet(ByVal uCode As Long, ByVal wParam As Long, lParam As CWPRETSTRUCT) As Long
'    If lParam.message = WM_NULL Then
    If lParam.message = WM_SETTEXT And lParam.hwnd = Form2.Text1.hwnd Then
        Select Case uCode
            Case HC_ACTION
'                Form2.Text1.Text = Form2.Text1.Text & "CALLWNDPROCRET" _
'                                                    & "    HWND:" & Hex$(lParam.hwnd) _
'                                                    & "    WPARAM:" & Hex$(lParam.wParam) _
'                                                    & "    LPARAM:" & Hex$(lParam.lParam) _
'                                                    & "    RETVAL:" & Hex$(lParam.lResult) _
'                                                    & "    CURRTHREAD:" & Hex$(wParam) _
'                                                    & "    InSM:" & InSendMessage() & vbNewLine
                DoEvents
                MsgBox "Inside the WH_CALLWNDPROCRET hook."
            Case Else
        End Select
    End If
    
    WndProcRet = CallNextHookEx(hProcRetHook, uCode, wParam, lParam)
End Function


Public Function WndProc(ByVal uCode As Long, ByVal wParam As Long, lParam As CWPSTRUCT) As Long
'    If lParam.message = WM_NULL Then
    If lParam.message = WM_SETTEXT And lParam.hwnd = Form2.Text1.hwnd Then
        Select Case uCode
            Case HC_ACTION
'                Form2.Text1.Text = Form2.Text1.Text & "CALLWNDPROC" _
'                                                    & "    HWND:" & Hex$(lParam.hwnd) _
'                                                    & "    WPARAM:" & Hex$(lParam.wParam) _
'                                                    & "    LPARAM:" & Hex$(lParam.lParam) _
'                                                    & "    CURRTHREAD:" & wParam _
'                                                    & "    InSM:" & InSendMessage() & vbNewLine
                DoEvents
                MsgBox "Inside the WH_CALLWNDPROC hook."
            Case Else
        End Select
    End If
    
    WndProc = CallNextHookEx(hProcHook, uCode, wParam, lParam)
End Function


Public Sub DummyCallback(ByVal hwnd As Long, ByVal uMsg As Long, ByVal dwData As Long, ByVal lResult As Long)
    'Do nothing and return
End Sub

