Attribute VB_Name = "Module2"
Option Explicit

Private Declare Function SetWindowsHookEx Lib "user32" Alias "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hmod As Long, ByVal dwThreadId As Long) As Long
Private Declare Function UnhookWindowsHookEx Lib "user32" (ByVal hHook As Long) As Long
Private Declare Function CallNextHookEx Lib "user32" (ByVal hHook As Long, ByVal ncode As Long, ByVal wParam As Long, lParam As Any) As Long


Public Const WH_CALLWNDPROC = 4
Public Const WH_CBT = 5
Public Const WH_DEBUG = 9
Public Const WH_FOREGROUNDIDLE = 11
Public Const WH_GETMESSAGE = 3
Public Const WH_HARDWARE = 8
Public Const WH_JOURNALPLAYBACK = 1
Public Const WH_JOURNALRECORD = 0
Public Const WH_KEYBOARD = 2
Public Const WH_MAX = 11
Public Const WH_MIN = (-1)
Public Const WH_MOUSE = 7
Public Const WH_MSGFILTER = (-1)
Public Const WH_SHELL = 10
Public Const WH_SYSMSGFILTER = 6

Private Const HC_ACTION = 0
Private Const HC_GETNEXT = 1
Private Const HC_SKIP = 2
Private Const HC_NOREMOVE = 3
Private Const HC_NOREM = HC_NOREMOVE
Private Const HC_SYSMODALOFF = 5
Private Const HC_SYSMODALON = 4


Public Type DEBUGHOOKINFO
        hModuleHook As Long
        Reserved As Long
        lParam As Long
        wParam As Long
        code As Long
End Type

Public Type POINTAPI
        x As Long
        y As Long
End Type

Public Type MSG
    hwnd As Long
    message As Long
    wParam As Long
    lParam As Long
    time As Long
    pt As POINTAPI
End Type


Private hHook As Long
Private hHook_DBG As Long

Public IsHooked As Boolean
Public IsDBGHooked As Boolean


'----------------------------------
' SET FOREGROUND IDLE FILTER HOOK
'----------------------------------
Public Sub SetIdleHook()
    If IsHooked Then
        MsgBox "Don't hook it twice without unhooking or you will be unable to unhook it."
    Else
        hHook = SetWindowsHookEx(WH_FOREGROUNDIDLE, AddressOf IdleProc, 0, App.ThreadID)

        IsHooked = True
    End If
End Sub

Public Sub RemoveIdleHook()
    Dim temp As Long
    temp = UnhookWindowsHookEx(hHook)
    IsHooked = False
End Sub


Public Function IdleProc(ByVal uCode As Long, ByVal wParam As Long, lParam As Long) As Long
    If uCode >= HC_ACTION Then
        If IsNumeric(Form2.Text1.Text) Then
            If CDbl(Form2.Text1.Text) > 100000 Then
                Form2.Text1.Text = "0"
            Else
                Form2.Text1.Text = CDbl(Form2.Text1.Text) + 1
            End If
        End If
    Else
        'Skip processing
    End If
    
    IdleProc = CallNextHookEx(hHook, uCode, wParam, lParam)
End Function


